<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

function init()
{
	var frm = document.forms['reggie'];
	var bioplates = getLibraryBioPlates();
	
	var plates = frm.bioplate;
	if (bioplates != null && bioplates.length > 0)
	{
		for (var i=0; i < bioplates.length; i++)
		{
			var bioplate = bioplates[i];
			var option = new Option(bioplate.name, bioplate.id);
			option.bioplate = bioplate;
			plates.options[plates.length] = option;
		}
		bioplateIsValid = true;
		Main.show('gocreate');
		bioPlateOnChange();
	}
	else
	{
		var msg = 'No Library bioplates available for processing.';
		setFatalError(msg);
		return;
	}
	
	var configurations = getConfigurationsForCaliperRunParametersExporter();
	var caliper96 = makeButton('Sample names for Caliper (96)', "goExport('CALIPER', 'SAMPLE_NAMES')");
	var caliper384 = makeButton('Sample names for Caliper (384)', "goExport('CALIPER', 'SAMPLE_NAMES_384')");
	for (var i = 0; i < configurations.length; i++)
	{
		var config = configurations[i];
		var btnHtml = makeButton('Run parameters: '+config.name, "goExport('CALIPER', "+config.id+")");
		if (config.name.indexOf('384') > 0)
		{
			caliper384 += btnHtml;
		}
		else
		{
			caliper96 += btnHtml;
		}
	}
	setInnerHTML('exportCaliper96', caliper96);
	setInnerHTML('exportCaliper384', caliper384);

	var qubit = makeButton('Sample names for Qubit', "goExport('QUBIT', 'SAMPLE_NAMES')");
	setInnerHTML('exportQubit', qubit);
	
}

function makeButton(title, onClick)
{
	var btn = '';
	btn += '<span class="link" onclick="'+onClick+'">';
	btn += '<img src="../images/export.png">&nbsp;';
	btn += title+'</span><br>\n';
	return btn;
}


function getLibraryBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Library bioplates...');
		var url = '../LibPrep.servlet?ID=<%=ID%>&cmd=GetLibraryPlatesForLibPrep';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.bioplates;
}


function getConfigurationsForCaliperRunParametersExporter()
{
	var request = Ajax.getXmlHttpRequest();
	var url = '../LibPrep.servlet?ID=<%=ID%>&cmd=GetConfigurationsForCaliperRunParametersExporter';		
	request.open("GET", url, false);
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.configurations;
}


function viewProtocol(type)
{
	var frm = document.forms['reggie'];
	if (frm.bioplate && !frm.bioplate.disabled)
	{
		frm.view.value = type;
		frm.submit();
	}
}

function goExport(hardware, exporter)
{
	var frm = document.forms['reggie'];	
	if (frm.bioplate && !frm.bioplate.disabled)
	{
		var bioPlateId = frm.bioplate[frm.bioplate.selectedIndex].value;
	
		var url;
		if (hardware == 'CALIPER')
		{
			if (exporter == 'SAMPLE_NAMES')
			{
				url = '../LibPrep.servlet?ID=<%=ID%>&cmd=ExportSampleNamesForCaliper&bioPlateId='+bioPlateId;
			}
			else if (exporter == 'SAMPLE_NAMES_384')
			{
				url = '../LibPrep.servlet?ID=<%=ID%>&cmd=ExportSampleNamesForCaliper&remapTo384=1&bioPlateId='+bioPlateId;
			}
			else
			{
				url = '../LibPrep.servlet?ID=<%=ID%>&cmd=ExportCaliperRunParameters&bioPlateId='+bioPlateId+'&configurationId='+exporter;
			}
		}
		else if (hardware == 'QUBIT')
		{
			if (exporter == 'SAMPLE_NAMES')
			{
				url = '../LibPrep.servlet?ID=<%=ID%>&cmd=ExportSampleNamesForQubit&bioPlateId='+bioPlateId;
			}
			else
			{
				alert('not implemented');
				return;
			}
		}
		window.location = url;
	}
}

function bioPlateOnChange()
{
	var frm = document.forms['reggie'];
	var bioplate = frm.bioplate[frm.bioplate.selectedIndex].bioplate;
	setInnerHTML('comments', formatText(bioplate.comments));
	frm.poolSchema.value = bioplate.poolSchema;
	frm.barcodeVariant.value = bioplate.barcodeVariant;
}
</script>
<style>
#export div
{
	margin-left: 1em;
}
</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab protocols for library preparation" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" action="libprep_protocol2.jsp" method="post" target="_blank">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="view" value="list">
	<input type="hidden" name="poolSchema" value="4by24">
	<input type="hidden" name="barcodeVariant" value="">
	
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select Library bioplate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Library bioplate</td>
				<td class="input"><select style="width:90%" 
						name="bioplate" id="bioplate" onchange="bioPlateOnChange()"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help" rowspan="2"><span id="bioplate.message" class="message" style="display: none;"></span>
					Select an existing Library bioplate. The list contain all Library bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">-comments</td>
				<td class="input" id="comments" style="font-style: italic; background: #E8E8E8; padding: 2px 5px 2px 5px;"></td>
				<td class="status" id="comments.status"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Lab protocols</td>
				<td class="input" id="protocol" style="white-space: nowrap; line-height: 1.5em;">
					<span class="link" onclick="viewProtocol('list')"><img src="../images/listview.png">&nbsp;List layout</span><br>
					<span class="link" onclick="viewProtocol('plate')"><img src="../images/plateview.png">&nbsp;Plate layout</span><br>
				</td>
				<td class="status" id="protocol.status"></td>
				<td class="help"><span id="protocol.message" class="message" style="display: none;"></span>
					The 'list layout' generates a table with one row for each well on the work plate.
					The 'plate layout' generates a grid with wells arranged according to row and column coordinates.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Export files</td>
				<td class="input" id="export" style="white-space: nowrap; line-height: 1.5em;">
					<i>Qubit</i>
					<div id="exportQubit"></div>
					<i>Caliper - 96 wells</i>
					<div id="exportCaliper96"></div>
					<i>Caliper - 384 wells</i>
					<div id="exportCaliper384"></div>
				</td>
				<td class="status" id="export.status"></td>
				<td class="help"><span id="protocol.message" class="message" style="display: none;"></span>
					<p>
					Select what to export. Typically, you'll need either the <b>96 or 384</b> version of 
					<b>Caliper</b> files and all of the <b>Qubit</b> files.
					<p>
					Tip! You can run the exporters for any bioplate as a regular plug-in by selecting 
					a bioplate from the list at <a 
					href="<%=request.getContextPath()%>/biomaterials/bioplates/index.jsp?ID=<%=ID%>"
					>Biomaterial LIMS › Bioplates</a> and then use the <b>Export</b> button. 
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>