<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="java.util.Calendar"
	import="java.util.Locale"
	import="java.text.SimpleDateFormat"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

function goExport(preview)
{
	var frm = document.forms['reggie'];
	var url = '../Export.servlet?ID=<%=ID%>&cmd=ExportMissingConsentDataSampleList';
	if (preview) 
	{
		var previewTitle = document.getElementById('previewTitle');
		var previewList = document.getElementById('previewList');
		
		Main.hide('previewWrapper');
		previewTitle.innerHTML = 'Working...';
		previewList.innerHTML = '';
		
		url += '&preview=1';
		var request = Ajax.getXmlHttpRequest();
		
		try
		{
			showLoadingAnimation('Working...');
			request.open("GET", url, false);	
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}

		if (request.status != 200)
		{
			Main.openPopup('', 'ErrorWindow', 800, 600);
			Main.getWindow('ErrorWindow').document.write(request.responseText);
		}
		else
		{
			var allLines = request.responseText.split('\n');
			var numCases = allLines.length - 2; // First line is a header line
			
			var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
			// Check last column for the 'Consent' value
			var numConsentWithoutDate = 0;
			var numMissingConsent = 0;
			var numYesConsent = 0;
			var numNoConsent = 0;
			var numNotAskedConsent = 0;
			for (var i = 1 ; i <= numCases; i++)
			{
				var line = allLines[i];
				var cols = line.split(/\t/);
				var consent = cols[cols.length-1];
				var rowClass = '';
				if (consent == null || consent == 'null')
				{
					rowClass = 'consent-warning';
					numMissingConsent++;
				}
				else if (consent == 'Yes')
				{
					numYesConsent++;
				}
				else if (consent == 'No')
				{
					numNoConsent++;
				}
				else if (consent == 'Not asked')
				{
					numNotAskedConsent++;
				}
				html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
			}
			numConsentWithoutDate = numCases - numMissingConsent;

			previewTitle.innerHTML = numCases + ' Samples = ' + numConsentWithoutDate + ' unknown date (' + numYesConsent + ' Yes, ' + numNoConsent + ' No, ' + numNotAskedConsent + ' Not asked) + ' + numMissingConsent + ' missing consent';
			previewList.innerHTML = '<table>'+html+'</table>';
			Main.show('previewWrapper');
		}
	}
	else
	{
		window.location = url;		
	}
	
}

</script>
<style>

.fullyear
{
	font-weight: bold;
}

#previewWrapper
{
	position: absolute;
	top: 11em;
	bottom: 1em;
	left: 20px;
	width: 950px;
	overflow: visible;
}

#previewList
{
	position: absolute;
	top: 1.5em;
	bottom: 0px;
	width: 950px;
	overflow: auto;
	white-space: pre; 
	font-family: monospace;
	border: 1px dotted #A0A0A0;
	border-radius: 4px;
	background: #E8E8E8;
	padding: 0.25em;
}

#previewTitle
{
	font-weight: bold;
}

#previewList th
{
	border-bottom: 1px dotted #A0A0A0;
}

#previewList td, #previewList th
{
	text-align: left;
	padding-right: 2em;
	vertical-align: bottom;
}

.consent-warning
{
	color: #A00000;
	background-color: #F8F8E8;
}

.consent-warning td:last-child
{
	background-image: url('../images/warning_small.png');
	background-position: 95% 50%;
	background-repeat: no-repeat;
}

</style>
</base:head>
<base:body >

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Export missing consent data sample list" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the export but 
			it may no include all items.
		</div>
		<%
	}
	%>
	<form name="reggie">
	
	<!-- 1. Select month -->
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<!--
		<td class="steptitle">Select month or year</td>
		-->
		<td class="steptitle">Parameters</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table width="100%">
			<tr>
				<td class="prompt">No parameters</td>
				<!--
				<td class="input">
					<select name="sampletype" onChange="sampleTypeOnChange()">
						<option value="specimen_nospecimen" selected="yes">Specimen/No specimen</option>
						<option value="blood">Blood</option>
					</select>
				</td>
				-->
				<td></td>
				<td class="help">Press a button to continue.<span id="time.message" class="message" style="display: none;"></span></td>
			</tr>			
			</table>
		</td>
	</tr>
	</table>

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gopreview" title="Preview" image="<%=home+"/images/export.png"%>" onclick="goExport(true)"/></td>
		<td><base:button id="goexport" title="Download" image="<%=home+"/images/download.png"%>" onclick="goExport(false)"/></td>
	</tr>
	</table>
	</form>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div id="previewWrapper" style="display: none;">
		<div>
			<span id="previewTitle">Preview</span>
			<span id="previewWarning"></span>
		</div>
		<div id="previewList"></div>
	</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>