<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="boxplot.js" type="text/javascript" charset="UTF-8"></script>
		
		
	<script language="JavaScript">
	var currentStep = 1;
	var debug = false;
/*
	var numCols;
	var unknownSite = 0;
	var unknownCreation;
	var numPatientsNoSamples = 0;
	var debug01 = null;
*/
	
	var intervalIsValid = true;
	
	function goNext()
	{
		if (currentStep == 1)
		{
			gotoStep2();
		}
	}
	
	function getSites()
	{
		// Get sites JSON object with AJAX
		var frm = document.forms['reggie'];
		var request = Ajax.getXmlHttpRequest();
		var url = '../ScanBQuarterMonthReport.servlet?ID=<%=ID%>&cmd=getsites';		
		request.open("GET", url, false); 
		request.send(null);
	
		if (debug) Main.debug(request.responseText);

		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
	
		// Get site information from the AJAX response
		var sitesList = response.sitesList;

		return sitesList;
	}

	function gotoStep2()
	{
		var frm = document.forms['reggie'];
		frm.reporttype.disabled = true;
		// Hide report period input fields
		document.getElementById("reportPeriodSubSection01").style.display = 'none';
		document.getElementById("reportPeriodSubSection02").style.display = 'none';
		document.getElementById("reportPeriodSubSection04").style.display = 'none';
		// Hide view type pop-up menu
		document.getElementById("viewTypeSubSection01").style.display = 'none';
		document.getElementById("viewTypeSubSection02").style.display = 'none';
		document.getElementById("viewTypeSubSection04").style.display = 'none';
		// Hide chart site pop-up menu
		document.getElementById("chartSiteSubSection01").style.display = 'none';
		document.getElementById("chartSiteSubSection02").style.display = 'none';
		document.getElementById("chartSiteSubSection04").style.display = 'none';
		// Hide chart variant pop-up menu
		document.getElementById("chartVariantSubSection01").style.display = 'none';
		document.getElementById("chartVariantSubSection02").style.display = 'none';
		document.getElementById("chartVariantSubSection04").style.display = 'none';
		if (frm.reporttype[frm.reporttype.selectedIndex].value == 'scanbquartermonthreport')
		{
			// Show report period input fields
			document.getElementById("reportPeriodSubSection01").style.display = 'block';
			document.getElementById("reportPeriodSubSection02").style.display = 'block';
			document.getElementById("reportPeriodSubSection04").style.display = 'block';
			document.getElementById("reportPeriodSubSection01Header").innerHTML="Report period";
			document.getElementById("reportPeriodSubSection04HelpText").innerHTML="Define which period the report should cover. Empty fields will include all items.";
			// Set item name for report time step text
			//document.getElementById("items02").innerHTML="samples";
			document.getElementById("items03").innerHTML="samples";
			document.getElementById("items04").innerHTML="samples";
			document.getElementById("items05").innerHTML="samples";
			// Show view type pop-up menu
			document.getElementById("viewTypeSubSection01").style.display = 'block';
			document.getElementById("viewTypeSubSection02").style.display = 'block';
			document.getElementById("viewTypeSubSection04").style.display = 'block';
			// Show chart site pop-up menu
			document.getElementById("chartSiteSubSection01").style.display = 'block';
			document.getElementById("chartSiteSubSection02").style.display = 'block';
			document.getElementById("chartSiteSubSection04").style.display = 'block';
			// Get sites dynamically from server data
			var sitesList = getSites();
			if (sitesList != null)
			{
				// Construct chart site menu from JSON data
				var chartSiteSelect = document.getElementById("chartSiteSelect");
				var sites = sitesList.sites;
				var siteOrderList = sitesList.siteOrderListKey;
				for (var siteOrderIndex in siteOrderList)
				{
					var sitePrefix = siteOrderList[siteOrderIndex];		
					if (!sites.hasOwnProperty(sitePrefix)) continue;				
					var site = sites[sitePrefix];
					var siteName = site['name'];
					// Create and add new option element to select menu
					var optionEl = document.createElement('option');
					optionEl.setAttribute('value',sitePrefix);
					optionEl.innerHTML = siteName;
					chartSiteSelect.appendChild(optionEl);
				}
			}
			// Show chart data pop-up menu
			document.getElementById("chartVariantSubSection01").style.display = 'block';
			document.getElementById("chartVariantSubSection02").style.display = 'block';
			document.getElementById("chartVariantSubSection04").style.display = 'block';
		}
		Main.show('itemCountSection');
				
		Main.show('gocreate');		
		Main.hide('gonext');
		frm.fromdate.focus();
		currentStep = 2;
	}
	
	function dateOnChange()
	{
		var frm = document.forms['reggie'];		
		var fdate;
		var tdate;
		
		intervalIsValid = false;
		setInputStatus('displayInterval','','valid');
		if (frm.fromdate.value != null && frm.fromdate.value != '')
		{
			frm.fromdate.value = autoFillDate(frm.fromdate.value);			
			if (!Dates.isDate(frm.fromdate.value, 'yyyyMMdd'))
			{
				setInputStatus('displayInterval','Not a valid from-date', 'invalid');
				return;
			}
			else
			{
				fdate = frm.fromdate.value;
				fdate = new Date(fdate.substr(0,4), parseInt(fdate.substr(4,2), 10)-1, fdate.substr(6,2));
			}
		}
		
		if (frm.todate.value != null && frm.todate.value != '')
		{
			frm.todate.value = autoFillDate(frm.todate.value);
			if (!Dates.isDate(frm.todate.value, 'yyyyMMdd'))
			{
				setInputStatus('displayInterval', 'Not a valid to-date', 'invalid');
				return;
			}
			else
			{
				tdate = frm.todate.value;
				tdate = new Date(tdate.substr(0,4), parseInt(tdate.substr(4,2), 10)-1, tdate.substr(6,2));
			}
		}
		
		if (tdate != null && fdate != null)
		{
			if (fdate > tdate)
			{
				setInputStatus('displayInterval', 'Invalid period', 'invalid')
				return;
			}			
		}
		intervalIsValid = true;
	}
	
	function goCreate()
	{
		if (!intervalIsValid) return;
		var frm = document.forms['reggie'];		
		var reportType = frm.reporttype[frm.reporttype.selectedIndex].value;		
		frm.fromdate.disabled = true;
		frm.todate.disabled = true;
		var chartSite = frm.chartvariant[frm.chartsite.selectedIndex].value;		
		var chartVariant = frm.chartvariant[frm.chartvariant.selectedIndex].value;		
		if (reportType == 'scanbquartermonthreport')
		{
			frm.viewtype.disabled = true;
			frm.chartsite.disabled = true;
			frm.chartvariant.disabled = true;
		}
		Main.hide('gocreate');
		Main.show('reportSection');
		var url = '../ScanBQuarterMonthReport.servlet?ID=<%=ID%>&cmd='+reportType;		
		
		if (frm.fromdate.value != null) url += '&fdate='+frm.fromdate.value;
		if (frm.todate.value != null) url += '&tdate='+frm.todate.value;
		if (reportType == 'scanbquartermonthreport')
		{			
			if (frm.viewtype.value != null) url += '&vtype='+frm.viewtype.value;
			if (frm.chartsite.value != null) url += '&csite='+frm.chartsite.value;
			if (frm.chartvariant.value != null) url += '&cvariant='+frm.chartvariant.value;
		}
		
		
		var request = Ajax.getXmlHttpRequest();
		request.open("GET", url, true);
		Ajax.setReadyStateHandler(request, onPlotGenerated);
		request.send(null);
	}
	
	function onPlotGenerated(request)
	{
		var frm = document.forms['reggie'];		
		var reportType = frm.reporttype[frm.reporttype.selectedIndex].value;		
		if (debug) Main.debug(Main.encodeTags(request.responseText));
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		var report = response.report;
		var permissionDeniedForPatientName = report.permissionDeniedForPatientName;
		var reportTable;
		var cellElement = document.getElementById('reportdiv');
		
		if (report != null)
		{
			if ('scanbquartermonthreport' == reportType)
			{
				var draw_area_wdt = 700;
				var draw_area_hgt = 550;
				var draw_scale_factor = 2;
				var jsonStatisticsPlotArray = report.plotStatistics;
				// Draw plots
				setInnerHTML('reportdiv', '');
				for (var plotIndex in jsonStatisticsPlotArray)
				{
					//
					// Get plot JSON data container with extra info and plot data
					var plotJsonDataContainer = jsonStatisticsPlotArray[plotIndex];
					// Get plot JSON extra info and plot data
					var plotChartVariant = plotJsonDataContainer['chartVariant'];
					var plotViewType = plotJsonDataContainer['viewType'];
					var plotOptionalHeadline = plotJsonDataContainer['optionalHeadline'];
					var boxPlotJsonData = plotJsonDataContainer['plotData'];
					// Create plot from plot JSON data
					if (plotOptionalHeadline != null && plotOptionalHeadline != '')
					{
						// Print optional headline
						var headlineText = document.createElement('text');
						headlineText.innerHTML = "<BR>" + plotOptionalHeadline + "<BR>";
						cellElement.appendChild(headlineText);
					}
					var plotKey = plotChartVariant + '_' + plotViewType;
/*
					// Add plot key as debug text
					var debugText = document.createElement('text');
					debugText.innerHTML = "<BR>" + plotKey + "<BR>";
					cellElement.appendChild(spacer);
					cellElement.appendChild(debugText);
*/
					// Add plot
					var canvasInTable = document.createElement('canvas');
					canvasInTable.setAttribute('id', plotKey);
					canvasInTable.setAttribute('width', draw_area_wdt * draw_scale_factor);
					canvasInTable.setAttribute('height', draw_area_hgt * draw_scale_factor);
					createBoxPlot(boxPlotJsonData, canvasInTable, draw_area_wdt, draw_area_hgt, draw_scale_factor);
					cellElement.appendChild(canvasInTable);					
					canvasInTable.addEventListener('mousemove', drawCanvasGuidelines, false);
					canvasInTable.addEventListener('mouseleave', hideCanvasGuidelines, false);
				}
				// Print optional appended info
				var appendedInfo = report.appendedInfo;
				if (appendedInfo != null && appendedInfo != '')
				{
					// Print optional headline
					var infoText = document.createElement('text');
					infoText.innerHTML = "<BR>" + appendedInfo + "<BR>";
					cellElement.appendChild(infoText);
				}
			}
		}
		else
		{
			var messageCell = getTableCellElement('No values could be found during given period', 'reportheader');
			var messageRow = document.createElement('tr');
			messageRow.appendChild(messageCell);			
			var messageTable = getReportTable();
			messageTable.appendChild(messageRow);
			reportTable = messageTable;			
		}
		Main.show('printButton');
		Main.show('gorestart');		
	}

	function getJSONData(jsonObject, key)
	{
		var data = getJSONData(jsonObject, key, '');
		return data;
	}

	function getJSONData(jsonObject, key, defaultChoice)
	{
		var data = defaultChoice;
		if (jsonObject != null)
		{
			if (jsonObject[key] != null)
			{
				data = jsonObject[key];
			}
		}
		return data;
	}

	function getReportTable()
	{
			var reportTable = document.createElement('table');
			reportTable.setAttribute('class','reporttable');
			reportTable.setAttribute('border','1');			
			return reportTable;
	}
	
	function getTableCellElement(text, clazz, colspan, rowspan)
	{
		var cellElement = document.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(document.createElement('br'));
				cellElement.appendChild(document.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(document.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}
	
	function getListElement(itemText)
	{
		var listElement = document.createElement('li');
		var textNode = document.createTextNode(itemText);
		listElement.appendChild(textNode);
		return listElement;
	}

	/**
	 *	addHyphensToDateStr()
	 *
	 *	Adds hyphens to date string in yyyymmdd format to
	 *	get yyyy-mm-dd format. If input string already contains
	 *	hyphen(s), the input string is returned unchanged.
	 *	If input string is null or empty, '????-??-??' is returned.
	 *
	 *	@param dateStr String Input date string in yyyy-mm-dd or yyyymmdd format.
	 *	@return String Date string in yyyy-mm-dd format.
	 */
	function addHyphensToDateString(dateStr)
	{
		var dateWithHyphensStr = '????-??-??';
		if (dateStr != null && dateStr != '')
		{
			// Check if input string already contains hyphen
			if (dateStr.indexOf("-") >= 0)
			{
				// Date already has hyphen(s)
				dateWithHyphensStr = dateStr;
			}
			else
			{
				// Date in yyyymmdd format
				var yearStr = dateStr.substr(0,4);
				var monthStr = dateStr.substr(4,2);
				var dayStr = dateStr.substr(6,2);			
				dateWithHyphensStr = yearStr + '-' + monthStr + '-' + dayStr;
			}
		}
		return dateWithHyphensStr;
	}

	/**
	 *	dateStrToDate()
	 *
	 *	Takes an input date string in yyyy-mm-dd or yyyymmdd format
	 *	and returns a date corresponding to the date string.
	 *	If input string is null or empty, null is returned.
	 *
	 *	@param dateStr String Input date string in yyyy-mm-dd or yyyymmdd format.
	 *	@return Date Date corresponding to input date string.
	 */
	function dateStrToDate(dateStr)
	{
		var date = null;
		if (dateStr != null && dateStr != '')
		{
			// Check if input string already contains hyphen
			if (dateStr.indexOf("-") >= 0)
			{
				// Date in yyyy-mm-dd format
				var yearStr = dateStr.substr(0,4);
				var monthStr = dateStr.substr(5,2);
				var dayStr = dateStr.substr(8,2);			
				var date = new Date(parseInt(yearStr, 10), parseInt(monthStr, 10)-1, parseInt(dayStr, 10));
			}
			else
			{
				// Date in yyyymmdd format
				var yearStr = dateStr.substr(0,4);
				var monthStr = dateStr.substr(4,2);
				var dayStr = dateStr.substr(6,2);			
				var date = new Date(parseInt(yearStr, 10), parseInt(monthStr, 10)-1, parseInt(dayStr, 10));
			}
		}
		return date;
	}

	/*
	 *	Get the ISO week number for a given date
	 * 
	 *	Based on code at http://stackoverflow.com/questions/6117814/get-week-of-year-in-javascript-like-in-php
	 *
	 *	@param date String Input date to get ISO week number for.
	 *	@return int ISO week number for input date.
	 */
	function getISOWeekNumber(date)
	{
		tmpDate = new Date(date);
		tmpDate.setHours(0,0,0);
		// Set to nearest Thursday: current date + 4 - current day number
		// Make Sunday day number 7
		tmpDate.setDate(tmpDate.getDate() + 4 - (tmpDate.getDay() || 7));
		// Get first day of year
		var yearStart = new Date(tmpDate.getFullYear(), 0, 1);
		// Calculate full weeks to nearast Thursday (86400000 = 24*60*60*1000 number of ms in a day)
		var weekNo = Math.ceil(( ( (tmpDate - yearStart) / 86400000) + 1)/7);
		return weekNo;
	}

	function goPrint()
	{
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.';
		printNote += ' Scale down to <i>90%</i> to fit 2 plots per page.';
		openPrintWindow('<%=ID%>', 'reportcell', 'Sample processing statistics', 'portrait', printNote, '../');
	}
	
	var xGuide;
	var yGuide;
	
	function drawCanvasGuidelines(event)
	{
		if (!xGuide)
		{
			xGuide = document.getElementById('x-guide');
			yGuide = document.getElementById('y-guide');
		}
		var canvas = event.target;
		var centerX = event.clientX;
		var centerY = event.clientY;
		var canvasPos = Main.getElementPosition(canvas);
		var startX = canvasPos.left+50;
		var widthX = canvasPos.width-100;
		var startY = canvasPos.top+80;
		var heightY = canvasPos.height-160;
		if (centerY < startY || centerY > startY+heightY)
		{
			// Hide when mouse is in the text area below or over the plot
			yGuide.style.display = 'none';
		}
		else
		{
			yGuide.style.top = (centerY-2) + 'px';
			yGuide.style.left = startX + 'px';
			yGuide.style.width = widthX + 'px';
			yGuide.style.display = 'block';
		}
		if (centerX < startX || centerX > startX + widthX)
		{
			// Hide when mouse is in the text area to the left or right of the plot
			xGuide.style.display = 'none';
		}
		else
		{
			// Avoid drawing outside the avilable hight (causes an extra pair of scroll bars)
			var yLimit = Main.getWindowHeight();
			if (startY+heightY > yLimit)
			{
				heightY = yLimit-startY;
			}
			xGuide.style.top = startY + 'px';
			xGuide.style.left = (centerX-2) + 'px';
			xGuide.style.height = heightY + 'px';
			xGuide.style.display = 'block';
		}

	}
	
	function hideCanvasGuidelines(event)
	{
		xGuide.style.display = 'none';
		yGuide.style.display = 'none';
	}
	</script>
	
	<style>
	canvas
	{
		width: 700px;
		height: 550px;
	}
	</style>
	</base:head>
	<base:body onload="init()">
		<p:path><p:pathelement 
			title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="Sample processing statistics" 
			/></p:path>
		<div id="x-guide" style="position: absolute; z-index: 99; display: none; background-color: #224488; width: 1px;"></div>
		<div id="y-guide" style="position: absolute; z-index: 99; display: none; background-color: #224488; height: 1px;"></div>
		<div class="content">
		<%
		if (sc.getActiveProjectId() == 0)
		{
			%>
			<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
				No project has been selected. You may proceed with the report generation but 
				only your own items will be included in the report.
			</div>
			<%
		}
		%>
	
		<form name="reggie">
			<!-- 1. Report type-->
			<table class="stepform">
			<tr>
				<td rowspan="3" class="stepno">1</td>
				<td class="steptitle">Report type</td>
			</tr>
			<tr>
				<td class="stepfields">
					<table width="100%">
					<tr valign="top">
						<td class="prompt">Report</td>
						<td class="input">
							<select name="reporttype">
								<option value="scanbquartermonthreport" selected="yes">SCAN-B quarter/month report</option>
							</select>
						</td>
						<td class="status" id="report.status"></td>
						<td class="help">
							<span id="report.message" class="message" style="display: none;"></span>
							Select which report to generate.
						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
			
			<div id="itemCountSection" style="display:none;">
				<p></p>
				<!-- 2. Report parameters-->
				<table class="stepform">
				<tr>
					<td rowspan="3" class="stepno">2</td>
					<td class="steptitle">Report parameters</td>
				</tr>
				<tr>
					<td class="stepfields">
						<table width="100%">						
						<tr>
							<td valign="top" class="prompt">
								<div id="reportPeriodSubSection01" style="display:none;">
									<text id="reportPeriodSubSection01Header">Report period</text>
								</div>
							</td>
							<td valign="top" class="input">
								<div id="reportPeriodSubSection02" style="display:none;">
									From<input type="text" onChange="dateOnChange()" size=7 name="fromdate"/>&nbsp;
									To<input type="text" onChange="dateOnChange()" size=7 name="todate" />
								</div>
							</td>
							<td valign="top" class="status" id="displayInterval.status"></td>
							<td class="help">
								<div id="reportPeriodSubSection04" style="display:none;">
									<span id="displayInterval.message" class="message" style="display: none;"></span>
									<!--
									Define which period the report should cover. Empty fields will include all <text id="items01">items</text>.<br>
									-->
									<text id="reportPeriodSubSection04HelpText">Parameter help text</text><br>
								</div>
							</td>
						</tr>	
						<tr>
							<td valign="top" class="prompt">
								<div id="viewTypeSubSection01" style="display:none;">
									View type
								</div>
							</td>
							<td valign="top" class="input">
								<div id="viewTypeSubSection02" style="display:none;">
									<select name="viewtype">
										<option value="QUARTERMONTH" selected="yes">Quarter + Month</option>
										<option value="AUTO">Auto</option>
										<option value="WEEK">Week</option>
										<option value="MONTH">Month</option>
										<option value="QUARTER">Quarter</option>
										<option value="YEAR">Year</option>
									</select>
								</div>
							</td>
							<td valign="top" class="status" id="displayViewType.status"></td>
							<td class="help">
								<div id="viewTypeSubSection04" style="display:none;">
									<span id="displayViewType.message" class="message" style="display: none;"></span>
									Auto will adjust the report depending on the size of the period.
									<ul>
										<!--
										<li>Period shorter than 3 months - <text id="items02">items</text> per week</li>
										-->
										<li>Period shorter than 13 months - <text id="items03">items</text> per month</li>
										<li>Period shorter than 3 years - <text id="items04">items</text> per quarter</li>
										<li>Period is 3 years or greater - <text id="items05">items</text> per year</li>
									</ul>
								</div>
							</td>
						</tr>
						<tr>
							<td valign="top" class="prompt">
								<div id="chartSiteSubSection01" style="display:none;">
									Chart site
								</div>
							</td>
							<td valign="top" class="input">
								<div id="chartSiteSubSection02" style="display:none;">
									<select id="chartSiteSelect" name="chartsite">
										<option value="allsitestogether" selected="yes">All sites together</option>
										<!-- Add sites to select menu dynamically from server data -->
									</select>
								</div>
							</td>
							<td valign="top" class="status" id="displaychartSite.status"></td>
							<td class="help">
								<div id="chartSiteSubSection04" style="display:none;">
									<span id="displaysite.message" class="message" style="display: none;"></span>
									Select what site to take input data from.
								</div>
							</td>
						</tr>
						<tr>
							<td valign="top" class="prompt">
								<div id="chartVariantSubSection01" style="display:none;">
									Chart data
								</div>
							</td>
							<td valign="top" class="input">
								<div id="chartVariantSubSection02" style="display:none;">
									<select name="chartvariant">
										<option value="allcharts" selected="yes">All</option>
										<option value="originalquantitytissue">Original quantity tissue</option>
										<option value="quantitytissueused">Quantity tissue used for SCAN-B specimens</option>
										<option value="histologypiecequantity">Histology piece quantity</option>
										<option value="remainingquantityforscanbspecimen">Remaining quantity for SCAN-B specimens</option>
										<option value="originalquantitydna">Original quantity DNA for SCAN-B extractions</option>
										<option value="originalquantityrna">Original quantity RNA for SCAN-B extractions</option>
										<option value="dnayield">DNA yield</option>
										<option value="rnayield">RNA yield</option>
										<option value="dnayieldcorrected">DNA yield (corrected for only processing half of the lysate volume)</option>
										<option value="rnayieldcorrected">RNA yield (corrected for only processing half of the lysate volume)</option>
										<option value="rnaqc">RNA QC</option>
										<option value="minutestornalater">Min to RNAlater</option>
									</select>
								</div>
							</td>
							<td valign="top" class="status" id="displaychartVariant.status"></td>
							<td class="help">
								<div id="chartVariantSubSection04" style="display:none;">
									<span id="displaychartVariant.message" class="message" style="display: none;"></span>
									Select what data to report.
								</div>
							</td>
						</tr>
						</table>
					</td>
				</tr>
				</table>
			</div>
			
			<div id="reportSection" style="display:none;">
				<p></p>
				<table class="stepform">
				<tr>
					<td rowspan="3" class="stepno">3</td>
					<td class="steptitle">Generated report
						<span id="printButton" class="link" style="float:right; display: none;" onclick="goPrint()"><img src="../images/print.png" style="padding-right: 0.5em;">Print version&hellip;</span>
					</td>
				</tr>
				<tr>
					<td id="reportcell" class="stepfields">
						<div id="reportdiv" style="text-align: center;">
							<div class="loading" id="loading">
							<table>
							<tr>
								<td><img src="../images/loading.gif"></td>
								<td id="loading.msg">Generating report...</td>
							</tr>
							</table>
							</div>
						</div>
					</td>
				</tr>
				</table>
			</div>	
			
			<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>		
				
			<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
				<tr>
					<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
					<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" /></td>
					<td><base:button id="gocreate" title="Generate" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>					
					<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
					<td id="gonext.message" class="message"></td>
				</tr>
			</table>			
		</form>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>