<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js,js-draw.js,menu.js" styles="path.css,toolbar.css,menu.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<link rel="stylesheet" type="text/css" href="../css/plate.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="plate.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="pools.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;

var quantitiesAreValid = false;
var QUANTITY_REGULAR;
var QUANTITY_QC;
var LOW_QUANTITY_WARNING_LIMIT;
var QUALITY_SCORE_WARNING_LIMIT;

var Rna = function()
{
	var rna = {};
	var flagged = [];
	var info = [];
	
	/**
		Create a new RNA object by name. More information
		about the RNA is automatically loaded from the database.
	*/
	rna.createByName = function(name)
	{
		var tmp = {};
		tmp.name = name;
		tmp.stratagene = name.indexOf(GENERIC_STRATAGENE_NAME) == 0;
		tmp.external = name == EXTERNAL_RNA_NAME;
		tmp.info = rna.infoByName(name);
		tmp.id = tmp.info.id;
		return tmp;
	}
	
	/**
		Create a new RNA object by info object.
	*/
	rna.createByInfo = function(info)
	{
		var tmp = {};
		tmp.name = info.name;
		tmp.stratagene = tmp.name.indexOf(GENERIC_STRATAGENE_NAME) == 0;
		tmp.external = tmp.name == EXTERNAL_RNA_NAME;
		tmp.id = info.id;
		tmp.info = info;
		return tmp;
	}
	
	/**
		Get information about a RNA item with a given name.
	*/
	rna.infoByName = function(name)
	{
		var key = 'N'+name;
		if (!info[key])
		{
			rna.loadInfoByNames([name]);
			if (!info[key]) info[key] = {};
		}
		return info[key];
	}

	/**
		Load and cache RNA information for all RNA items with a name in the
		given list.
	*/
	rna.loadInfoByNames = function(names)
	{
		var submitInfo = {};
		submitInfo.names = names;
		if (debug) Main.debug(JSON.stringify(submitInfo));

		var request = Ajax.getXmlHttpRequest();
		var url = '../MRna.servlet?ID=<%=ID%>&cmd=GetRnaInfoFromNames';	
		request.open("POST", url, false);
		request.setRequestHeader("Content-Type", "application/json");
		request.send(JSON.stringify(submitInfo));

		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		
		rna.cacheInfo(response.rna);
	}
	
	rna.cacheInfo = function(rnaList)
	{
		for (var i = 0; i < rnaList.length; i++)
		{
			var r = rnaList[i];
			info['N'+r.name] = r;
			info['I'+r.id] = r;
			if (r.flag) flagged[flagged.length] = r;
		}
	}

	rna.unflag = function(r)
	{
		if (!r.info || !r.info.flag) return false;

		r.info.flag = null;
		for (var i = 0; i < flagged.length; i++)
		{
			if (r.id == flagged[i].id)
			{
				flagged.splice(i, 1);
				break;
			}
		}
		return true;
	}
	
	rna.flag = function(r, flag)
	{
		if (!r.info || r.info.flag) return false;
		r.info.flag = flag;
		flagged[flagged.length] = r.info;
	}
	
	rna.getFlagged = function()
	{
		return flagged;
	}
	
	return rna;
}();

var WellPainter = function()
{
	var painter = {};
	
	// Add class indicators for replicates and QC assigned wells
	painter.getClassNameForWell = function(well)
	{
		var cls = '';
		if (well.extract)
		{
			if (well.replicate) cls += ' replicate';
			if (well.extract.qc) cls += ' qc';
		}
		return cls;
	}
	
	painter.getWellText = function(well)
	{
		var text = '';
		if (well.duplicates)
		{
			well.setError('Duplicate RNA in this location');
			text += '<div class="name">'+well.duplicates.join(', ')+'</div>';
		}
		else if (well.extract)
		{
			// The well contains RNA
			var rna = well.extract;
			var info = rna.info;
			text += '<div class="name">'+rna.name+'</div>';
			
			var warningMsg = [];
			if (info.bioWell)
			{
				var rnaWell = info.bioWell;
				text += '<div class="location">'+rnaWell.bioPlate.name+'['+rnaWell.location+']</div>';
			}
			else if (!rna.stratagene && !rna.external)
			{
				warningMsg[warningMsg.length] = 'No location';
			}

			if (info && info.id && !rna.stratagene && !rna.external)
			{
				var quantity = 10000 * (rna.qc ? QUANTITY_QC : QUANTITY_REGULAR);
				var use = Math.ceil(quantity/info.NDConc) / 10;
				var water = Math.round(50-use);
				if (info.remainingQuantity)
				{
					text += '<div class="quantity">'+Numbers.formatNumber(info.remainingQuantity, 2) + 'µg</div>';
					// Must have at least 1.1µg or 1.22µg (if default values are used)
					var remainLimit = rna.qc ? QUANTITY_QC : QUANTITY_REGULAR;
					if (info.remainingQuantity < remainLimit)
					{
						if (!warningMsg) warningMsg = 'Low quantity';
					}
					// Warning if near the limit
					if (info.remainingQuantity < LOW_QUANTITY_WARNING_LIMIT)
					{
						warningMsg[warningMsg.length] = 'Low quantity';
					}
				}
				else
				{
					warningMsg[warningMsg.length] = 'No quantity';
				}
				if (info.rqs)
				{
					text += '<div class="quality-score">RQS='+Numbers.formatNumber(info.rqs, 1) + '</div>';
					if (info.rqs < QUALITY_SCORE_WARNING_LIMIT) warningMsg[warningMsg.length] = 'Low RQS value';
				}
				else if (info.rin)
				{
					text += '<div class="quality-score">RIN='+Numbers.formatNumber(info.rin, 1) + '</div>';
					if (info.rin < QUALITY_SCORE_WARNING_LIMIT) warningMsg[warningMsg.length] = 'Low RIN value';
				}
				else
				{
					warningMsg[warningMsg.length] = 'No RQS/RIN value';
				}
				if (info.NDConc)
				{
					text += '<div class="ndconc">'+Numbers.formatNumber(info.NDConc, 2) + 'ng/µl</div>';
					text += '<div class="volumes"><span class="volume">'+Numbers.formatNumber(use, 1)+'</span> + <span class="water">'+Numbers.formatNumber(water, 1)+'µl</span></div>';
				}
				else
				{
					warningMsg[warningMsg.length] = 'No NDConc value';
				}
				if (info.QiaCubeDate)
				{
					text += '<div class="qiacube-date">'+info.QiaCubeDate+'</div>';
				}
				else
				{
					warningMsg[warningMsg.length] = 'No QiaCubeDate value';
				}
			}
			else if (!rna.id)
			{
				well.setError('RNA not found');
			}
			if (rna.comment)
			{
				text += '<div class="comment">'+Main.encodeTags(rna.comment)+'</div>';
			}
			if (info && info.comment)
			{
				text += '<div class="comment">'+Main.encodeTags(info.comment)+'</div>';
			}
			if (warningMsg.length > 0)
			{
				well.setWarning(warningMsg.join('; '));
			}
		}
		else if (well.copyText)
		{
			text = '<div class="copy-text">'+well.copyText+'</div>';
		}
		else
		{
			text = 'empty';
		}
		return text;
	}
	
	return painter;
}();


var graphics;
var pen;

function init()
{
	loadStratagene();
	
	keepSessionAlive('<%=ID%>', false, '../');
	
	quantityOnBlur();
	warningLevelOnBlur();
	
	var frm = document.forms['reggie'];
	var schema = PoolSchema.initList(frm.pool_schema);

	Plate.init(8, 12, schema, WellPainter);
	Plate.paint(Plate.getWells());
	PoolSchema.buildPoolTableRow(schema, 12, true);
	
	var specialSelect = document.getElementById('iconSpecialSelect');
	specialSelect.addEventListener('click', toggleSpecialSelect);
	
	graphics = new jsGraphics(document.getElementById('canvas'));
	pen = new jsPen(new jsColor('#2288AA'), 2);
	
	Plate.name = findNextMRnaPlateName();
	setInnerHTML('plateName', Plate.name);
}

function loadStratagene()
{
	var request = Ajax.getXmlHttpRequest();
	var url = '../MRna.servlet?ID=<%=ID%>&cmd=GetStratagene';	
	if (debug) Main.debug(url);
	request.open("GET", url, false);	
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var stratagene = response.stratagene;
	
	var frm = document.forms['reggie'];

	for (var i = 0; i < stratagene.length; i++)
	{
		var s = stratagene[i];
		var name = s.name;
		if (s.bioWell)
		{
			name += ' -- ' + s.bioWell.bioPlate.name + ' ('+s.bioWell.location + ')';
		}
		frm.stratagene[frm.stratagene.length] = new Option(name, s.name);
	}
	
}

function findNextMRnaPlateName()
{
	var request = Ajax.getXmlHttpRequest();
	var url = '../MRna.servlet?ID=<%=ID%>&cmd=GetNextAutoGeneratedPlateName&bioPlateType=MRNA';	
	if (debug) Main.debug(url);
	request.open("GET", url, false);	
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.name;
}


// Toggle the 'special select' menu on and off
function toggleSpecialSelect(event)
{
	var specialSelect = document.getElementById('iconSpecialSelect');
	var pos = Main.getElementPosition(specialSelect);
	Menu.toggleTopMenu(document.getElementById('menuSpecialSelect'), pos.left+pos.width/4, pos.top+pos.height); 
	event.stopPropagation();
}

/**
	Parse a tab-separated data file. The columns must be in the following order:
	0: RNA name
	1: Row letter (A-H)
	2: Column number (1-12)
	3: QC flag (can be empty)
*/
function parseRnaFile(data)
{
	var lines = data.split(/[\n\r]+/);

	// Load information about all RNA items in a batch (will improve performance)
	var names = [];
	for (var i = 0; i < lines.length; i++)
	{
		var line = lines[i];
		if (line)
		{
			var cols = lines[i].split(/\t/);
			if (cols.length < 3) throw 'On line '+(i+1)+': Too few columns (' + cols.length + ')';
			names[names.length] = cols[0];
		}
	}
	Rna.loadInfoByNames(names);
	
	// Place RNA on the plate
	var duplicates = [];
	for (var i = 0; i < lines.length; i++)
	{
		var line = lines[i];
		if (line)
		{
			var cols = lines[i].split(/\t/);

			var rna = Rna.createByName(cols[0]);
			var row =  WELL_ALPHA.indexOf(cols[1].toUpperCase());
			var col =  parseInt(cols[2], 10)-1;
			
			var well = Plate.getWell(row, col);
			if (!well) throw 'On line '+(i+1)+': Invalid plate coordinate ['+cols[1]+','+cols[2]+']';

			rna.qc = cols.length >= 4 && cols[3];
			Rna.unflag(rna);
			
			// Check for duplicate RNA on same position (which is an error)
			var pos = 'c'+col+'r'+row;
			if (duplicates[pos])
			{
				well.addDuplicate(rna);
			}
			else
			{
				duplicates[pos] = rna.name;
				well.setExtract(rna);
			}
		}
	}
	
	updateNumFlaggedRna();
	
	// Check for replicates on the whole plate and repaint it
	Plate.checkReplicates(null, true);
	Plate.paint(Plate.getWells());
}

/**
	Add 'Stratagene' to the selected wells.
*/
function setToStratagene()
{
	var frm = document.forms['reggie'];
	setToSpecial(frm.stratagene.value, true);
}

/**
	Add 'External RNA' to the selected wells.
*/
function setToExternal()
{
	setToSpecial(EXTERNAL_RNA_NAME, false);	
}

/**
	Add special RNA to the selected wells.
*/
function setToSpecial(specialName, qc)
{
	var wells = Plate.getSelected();
	
	if (wells.length == 0)
	{
		alert('No wells have been selected');
		return;
	}
	
	// Count non-empty wells
	var count = 0;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		if (well.extract && !well.hasError()) count++;
	}
	
	if (count > 0)
	{
		if (!confirm('Replace RNA in ' + count + ' wells with '+specialName+'?'))
		{
			return;
		}
	}
	
	var info = Rna.infoByName(specialName);
	if (!info.id)
	{
		alert('Could not find any RNA with name=\''+specialName+'\'. Please check that it exists on the server.');
		return;
	}
	
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		var rna = Rna.createByInfo(info);
		rna.qc = qc;
		well.setExtract(rna);
		well.selected = false;
	}
	
	Plate.paint(wells);
	
	// Check for replicated RNA if some have been replaced with Stratagene
	if (count > 0) Plate.checkReplicates();
}



/**
	Toggle the QC flag for the selected wells. The first non-empty
	well is toggled and the rest of the wells will use the same new QC
	value.
*/
function toggleQc()
{
	var wells = Plate.getSelected();

	if (wells.length == 0) 
	{
		alert('No wells have been selected');
		return;
	}
	
	var gotQc = false;
	var newQc;
	var count = 0;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		if (well.extract)
		{
			// Toggle QC flag for the first well with RNA, then use the same flag for the rest
			if (!gotQc)
			{
				gotQc = true;
				newQc = !well.extract.qc;
			}
			well.extract.qc = newQc;
			count++;
		}
	}
	
	if (count == 0)
	{
		alert('None of the selected wells contain any RNA');
	}
	else
	{
		Plate.paint(wells);
	}
}

/**
	Empty the selected wells from RNA. They can later be pasted again.
*/
function cutSelected()
{
	var wells = Plate.getSelected();
	
	if (wells.length == 0)
	{
		alert('No wells have been selected');
		return;
	}
	
	var count = 0;
	var valid = 0;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		if (well.extract) 
		{
			count++;
			if (!well.hasError()) valid++;
		}
	}
	
	if (count == 0)
	{
		alert('None of the selected wells contain any RNA');
		return;
	}
	
	// Ask for confirmation before deleting from valid wells
	if (valid > 0)
	{
		if (!confirm('Clear RNA from ' + count + ' of ' + wells.length + ' selected wells?'))
		{
			return;
		}
	}

	copySelected();
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		well.setExtract(null);
		well.selected = false;
	}
	Plate.paint(wells);
	Plate.checkReplicates();
}

var copy;
/**
	Copy information about the selected wells. 
*/
function copySelected()
{
	// Clear existing wells in the copy
	var repaint = [];
	if (copy && copy.length > 0)
	{
		for (var i = 0; i < copy.length; i++)
		{
			var cp = copy[i];
			cp.well.doneWithCopy();
			repaint[repaint.length] = cp.well;
		}
	}
	Plate.paint(repaint);
	
	// Place selected wells in the copy
	var wells = Plate.getSelected();
	copy = [];
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		copy[copy.length] = well.makeCopy();
		well.selected = false;
	}
	Plate.paint(wells);
}

/**
	Paste information into the selected wells.
*/
function pasteToSelected()
{
	if (!copy || copy.length == 0) 
	{
		alert('Nothing to paste. Please cut or copy wells first.');
		return;
	}
	
	var wells = Plate.getSelected();
	// Count non-empty and valid wells
	var count = 0;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		if (well.extract && !well.hasError()) count++;
	}
	
	if (count > 0)
	{
		if (!confirm('Replace RNA in ' + count + ' wells with copy?'))
		{
			return;
		}
	}
	
	var wi = 0;
	var ci = 0;
	var copyEmpty;
	var askIfEmpty = true;
	var repaint = [];
	
	while (wi < wells.length && ci < copy.length)
	{
		var well = wells[wi];
		var cp = copy[ci];
		var rna = null;
		cp.well.doneWithCopy();
		repaint[repaint.length] = cp.well;
		if (cp.name)
		{
			rna = Rna.createByName(cp.name);
			rna.comment = cp.comment;
		}
		else
		{
			// The copy is from an empty well
			if (askIfEmpty)
			{
				askIfEmpty = false;
				copyEmpty = confirm('Do you want to copy empty wells? If not, only non-empty well are copied.');
			}
		}
		if (rna != null || copyEmpty)
		{
			well.setExtract(rna);
			well.selected = false;
			repaint[repaint.length] = well;
			wi++;
		}
		ci++;
	}
	Plate.paint(repaint);
	copy.splice(0, ci);
	Plate.checkReplicates();
}

/*
	If exactly two wells have been selected, switch the RNA in them.
*/
function switchSelected()
{
	var wells = Plate.getSelected();

	if (wells.length != 2)
	{
		alert('Exactly 2 wells must be selected');
		return;
	}

	var rna0 = wells[0].extract;
	var rna1 = wells[1].extract;
	
	wells[0].setExtract(rna1);
	wells[1].setExtract(rna0);
	Plate.paint(wells);
}

// Set a comment on the selected wells
function commentSelected(comment)
{
	var wells = Plate.getSelected();
	
	if (comment == undefined)
	{
		if (wells.length == 0)
		{
			alert('No wells have been selected');
			return;
		}
		
		var count = 0;
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			if (well.extract) 
			{
				count++;
				if (well.extract.comment) comment = well.extract.comment;
			}
		}
		
		if (count == 0)
		{
			alert('None of the selected wells contain any RNA');
			return;
		}

		comment = prompt('Comment', comment || '');
		if (comment == null) return;
	}
	
	if (comment == '') comment = null;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		if (well.extract) well.extract.comment = comment;
	}
	Plate.paint(wells);
}

//Flag the selected RNA
function flagSelected(flag)
{
	var wells = Plate.getSelected();
	
	if (wells.length == 0)
	{
		alert('No wells have been selected');
		return;
	}
	
	var comment = null;
	if (flag == 'ManualFlag')
	{
		// Check if a comment has been set on any of the RNA
		for (var i = 0; i < wells.length; i++)
		{
			var well = wells[i];
			if (well.extract && well.extract.info) 
			{
				if (well.extract.info.comment) comment = well.extract.info.comment;
			}
		}
		comment = prompt('Comment', comment || '');
		if (!comment) return;
	}
	
	var count = 0;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		var rna = well.extract;
		if (rna && !rna.stratagene && !rna.external)
		{
			Rna.flag(rna, flag);
			rna.info.comment = comment;
			well.setExtract(null);
			count++;
		}
		well.selected = false;
	}
	
	updateNumFlaggedRna();
	Plate.paint(wells);
}


/**
	Open a popup dialog for selecting a data files.
*/
function selectFile()
{
	Main.openPopup('select_file.jsp?ID=<%=ID%>', 'SelectFile', 600, 400);	
}


/**
	Let the wizard automatically select among unprocessed RNA items.
*/
function autoSelect(options)
{

	var wells = Plate.getWells();
	var selected = [];
	var ignore = [];
	var notEmpty = 0;
	
	// Count selected and non-empty wells and keep track of RNA that is already present
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		if (well.selected) 
		{
			selected[selected.length] = well;
			if (well.extract && !well.hasError()) notEmpty++;
		}
		if (well.extract && well.extract.id)
		{
			ignore[ignore.length] = well.extract.id;
		}
	}
	// Ignore RNA already flagged
	var flagged = Rna.getFlagged();
	for (var i = 0; i < flagged.length; i++)
	{
		var rna = flagged[i];
		if (rna.id) ignore[ignore.length] = rna.id;
	}
	
	if (!options)
	{
		if (selected.length == 0)
		{
			alert('Please select one or more wells were RNA should be placed.');
			return;
		}
		
		if (notEmpty > 0)
		{
			if (!confirm('Replace RNA in ' + notEmpty + ' wells?'))
			{
				return;
			}
		}
		
		var url = 'auto_select_rna.jsp?ID=<%=ID%>';
		Main.openPopup(url, 'AutoSelectRNA', 600, 400);

	}
	else
	{
		var request = Ajax.getXmlHttpRequest();
		var url = '../MRna.servlet?ID=<%=ID%>&cmd=AutoSelectRnaForMRna&numToSelect='+selected.length;
		url += '&ignore='+ignore.join(',');
		
		options.ignore = ignore;
		if (debug) Main.debug(JSON.stringify(options));
		
		request.open("POST", url, false);
		request.send(JSON.stringify(options));

		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		
		// Cache RNA information
		Rna.cacheInfo(response.rna);
		Rna.cacheInfo(response.flagged);
		
		if (response.rna.length == 0)
		{
			return 'Could not find any unprocessed RNA at this time.';
		}
		
		updateNumFlaggedRna();
		
		for (var i = 0; i < response.rna.length; i++)
		{
			if (i < selected.length)
			{
				var well = selected[i];
				// Create a new RNA object
				var rna = Rna.createByName(response.rna[i].name);
				well.setExtract(rna);
				well.selected = false;
			}
		}
		
		// Check for replicates on the whole plate and repaint it
		Plate.checkReplicates(null, true);
		Plate.paint(Plate.getWells());
		
	}
}


var currentSelected;
var currentIndex = 0;
var subtypeRna = null;

/**
	Open a popup dialog for manual selection of RNA.
 */
function manualSelect()
{
	currentSelected = Plate.getSelected();
	currentIndex = 0;
	
	if (currentSelected.length == 0)
	{
		alert('Please select one or more wells were RNA should be placed.');
		return;
	}
	
	if (subtypeRna == null)
	{
		var request = Ajax.getXmlHttpRequest();
		var url = '../Subtype.servlet?ID=<%=ID%>&cmd=GetSubtypeInfo&name=RNA';
		request.open("GET", url, false);	
		request.send(null);

		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		subtypeRna = response.subtype;
	}

	var url = getRoot() + 'biomaterials/extracts/index.jsp?ID=<%=ID%>';
	url += '&cmd=UpdateContext&mode=selectmultiple&callback=setRnaCallback&resetTemporary=1';
	url += '&tmpfilter:INT:itemSubtype='+subtypeRna.id;
	url += '&tmpfilter:DATE:creationEvent.eventDate='+encodeURIComponent('<>');
	url += '&tmpfilter:FLOAT:remainingQuantity='+encodeURIComponent('>=1');
	url += '&'+encodeURIComponent('tmpfilter:STRING:&childCreationEvents(event.bioMaterial.name)')+'='+encodeURIComponent('<>%.m');
	Main.openPopup(url, 'SelectRNA', 1000, 700);
}

/**
	Callback method for manual selection.
*/
function setRnaCallback(id, name)
{
	if (currentIndex >= currentSelected.length)
	{
		return;
	}
	var well = currentSelected[currentIndex];
	
	// Keep a reference to the old rna in the well
	var oldRna = well.extract;

	// Create a new RNA object
	var rna = Rna.createByName(name);
	if (Rna.unflag(rna)) updateNumFlaggedRna();
	well.setExtract(rna);
	well.selected = false;
	Plate.paint([well]);
	
	// Update replicate information
	Plate.checkReplicates(name);
	if (oldRna) Plate.checkReplicates(oldRna.name);
	
	// Move to the next item
	currentIndex++;
}

// Update the 'Flagged RNA' information
function updateNumFlaggedRna()
{
	var numFlagged = Rna.getFlagged().length;
	if (numFlagged > 0)
	{
		setInnerHTML('flaggedRna', numFlagged + ' flagged RNA items.');
		Main.show('flaggedRna');
	}
	else
	{
		Main.hide('flaggedRna');
	}
}

// Toggle the selected status of a single well
function toggleWell(row, column)
{
	var well = Plate.getWell(row, column);
	Plate.toggleSelected([well]);
}

// Toggle the selected status of a complete row
function toggleRow(row)
{
	Plate.toggleSelected(Plate.getRow(row));
}

// Toggle the selected status of a complete column
function toggleColumn(column)
{
	Plate.toggleSelected(Plate.getColumn(column));
}

// Toggle the selected status of all wells
function toggleAll()
{
	Plate.toggleSelected(Plate.getWells());
}

// Toggle the selected status of a complete pool (=two columns)
function togglePool(pool)
{
	Plate.toggleSelected(Plate.getPool(pool));
}
function poolOnClick(event)
{
	var pool = event.target.getAttribute('data-pool-num');
	if (pool) togglePool(pool);
}
function poolEnter(event)
{
	var pool = event.target.getAttribute('data-pool-num');
	if (pool) highlightPool(pool, true);
}
function poolLeave(event)
{
	var pool = event.target.getAttribute('data-pool-num');
	if (pool) highlightPool(pool, false);
}


// Some special toogle operations
function specialToggle(what)
{
	var wells = [];
	if (what == 'all' || what == 'empty' || what == 'none')
	{
		// All wells or all empty (will be filtered later)
		wells = Plate.getWells();
	}
	else if (what == 'pools' || what == 'empty-pools')
	{
		// All primary pools or all empty in the primary pools (will be filtered later)
		for (var i = 0; i < Plate.poolSchema.numPools; i++)
		{
			wells = wells.concat(Plate.getPool(i));
		}
	}
	else if (what == 'stratagene')
	{
		// All wells with 'Stratagene'
		var tmp = Plate.getWells();
		for (var i = 0; i < tmp.length; i++)
		{
			var well = tmp[i];
			if (well.extract && well.extract.stratagene) wells[wells.length] = well;
		}
	}
	else if (what == 'external')
	{
		// All wells with 'External RNA'
		var tmp = Plate.getWells();
		for (var i = 0; i < tmp.length; i++)
		{
			var well = tmp[i];
			if (well.extract && well.extract.external) wells[wells.length] = well;
		}
	}
	else if (what == 'replicates')
	{
		// All wells with replicated RNA
		var tmp = Plate.getWells();
		for (var i = 0; i < tmp.length; i++)
		{
			var well = tmp[i];
			if (well.extract && well.replicate) wells[wells.length] = well;
		}
	}
	else if (what == 'error')
	{
		// All wells with an error
		var tmp = Plate.getWells();
		for (var i = 0; i < tmp.length; i++)
		{
			var well = tmp[i];
			if (well.hasError()) wells[wells.length] = well;
		}
	}
	else if (what == 'warning')
	{
		// All wells with a warning
		var tmp = Plate.getWells();
		for (var i = 0; i < tmp.length; i++)
		{
			var well = tmp[i];
			if (well.warning) wells[wells.length] = well;
		}
	}
	
	// Extra filter for empty wells only
	if (what.indexOf('empty') != -1)
	{
		var tmp = wells;
		wells = [];
		for (var i = 0; i < tmp.length; i++)
		{
			if (!tmp[i].extract) wells[wells.length] = tmp[i];
		}
	}
	
	if (what == 'none')
	{
		Plate.setSelected(wells, false);
	}
	else
	{
		Plate.toggleSelected(wells);
	}
}

// Highlight enable/disable all wells in a column
function highlightColumn(column, on)
{
	Main.addOrRemoveClass(document.getElementById('col.'+column), 'highlight-column', on);
	var wells = Plate.getColumn(column);
	Plate.setHighlight(wells, 'highlight-column', on);
}

// Highlight enable/disable all wells in a row
function highlightRow(row, on)
{
	Main.addOrRemoveClass(document.getElementById('row.'+row), 'highlight-row', on);
	var wells = Plate.getRow(row);
	Plate.setHighlight(wells, 'highlight-row', on);
}

// Highlight enable/disable all wells in a pool
function highlightPool(pool, on)
{
	Main.addOrRemoveClass(document.getElementById('pool.'+pool), 'highlight-pool', on);
	var wells = Plate.getPool(pool);
	Plate.setHighlight(wells, 'highlight-pool', on);
}

/**
	Highlight all replicated wells with the same RNA as the given well.
*/
function highlightReplicated(row, column, on)
{
	var well = Plate.getWell(row, column);
	if (well.extract && well.replicate)
	{
		// Get center coordinates for the current well
		var pos = Main.getElementPosition(well.tag);
		var jsPos = new jsPoint(pos.left+pos.width/2, pos.top+pos.height/2);

		var replicated = Plate.getWellsByName(well.extract.name);
		for (var i = 0; i < replicated.length; i++)
		{
			var rep = replicated[i];
			if (rep != well)
			{
				Main.addOrRemoveClass(rep.tag, 'highlight-replicated', on);
				if (rep.line)
				{
					// Clear any recent lines
					graphics.clearDrawing(rep.line);
					rep.line = null;
				}
				if (on)
				{
					// We draw a line between the current and replicated well
					var rPos = Main.getElementPosition(rep.tag);
					rep.line = graphics.drawLine(pen, jsPos, new jsPoint(rPos.left+rPos.width/2, rPos.top+rPos.height/2));
				}
			}
		}
	}
}

var contextRNA = null;
/**
	Reacts to 'mouseup' and 'contextmenu' events for the bioplate. 
	This should bring up the cut/copy/paste context menu depending on which
	mouse button that was clicked.
*/
function contextEvent(event)
{
	var frm = document.forms['reggie'];
	// Context menu on 'right' mouse button
	// Can't just check the button since two events are sent ('mouseup' and 'contextmenu')
	var showContext = event.type == 'contextmenu' && event.button == 2;
		
	if (showContext)
	{
		event.preventDefault(); // Prevents the default right-click menu from appearing
		
		// Get the well that is right-clicked and the RNA that is in it
		contextRNA = null;
		var well = event.target;
		while (well && (!well.id || well.id.indexOf('well') != 0))
		{
			well = well.parentNode;
		}
		if (well)
		{
			var c = well.id.split(/\./);
			contextRNA = Plate.getWell(parseInt(c[1]), parseInt(c[2])).extract;
		}
		// Update the context meny
		var caseSummaryMenu = document.getElementById('mnuCaseSummary');
		if (contextRNA)
		{
			caseSummaryMenu.title = 'Show case summary for ' + contextRNA.name;
			Main.show('sepCaseSummary');
			Main.show('mnuCaseSummary');
		}
		else
		{
			Main.hide('sepCaseSummary');
			Main.hide('mnuCaseSummary');
		}
		
		var menu = document.getElementById('menuContext');
		// 1 pixel offset to avoid losing well focus outline
		contextX = event.clientX+1;
		contextY = event.clientY+1;
		// Need short delay since 'mouseup' are also sent as 'click' events
		// to the 'document' object which BASE already have a Menu.hideAll()
		// call which would hide the menu immediately
		setTimeout(showContextMenu, 100);
	}
}

function showCaseSummary()
{
	if (!contextRNA) return;
	var caseName = contextRNA.name.substring(0, 7);
	var url = '../reports/case_summary.jsp?ID=<%=ID%>&caseName='+encodeURIComponent(caseName);
	url += '&pageType=popup';
	Main.openPopup(url, 'CaseSummary'+caseName, 1000, 700);
}

var contextX;
var contextY;
function showContextMenu()
{
	Menu.showTopMenu(document.getElementById('menuContext'), contextX, contextY);
}

function goCreate()
{
	if (!quantitiesAreValid)
	{
		setInnerHTML('gonext.message', 'Invalid RNA quantities');
		return;
	}
	
	var submitInfo = {};
	var plateInfo = {};
	var flaggedRnaInfo = [];
	
	submitInfo.bioplate = plateInfo;
	submitInfo.flagged = flaggedRnaInfo;
	var frm = document.forms['reggie'];
	var schema = POOL_SCHEMA[frm.pool_schema.selectedIndex];
	
	plateInfo.name = Plate.name;
	plateInfo.comments = frm.comments.value;
	plateInfo.poolSchema = schema ? schema.id : null;
	plateInfo.wells = [];

	var wells = Plate.getWells();
	var numErrors = 0;
	var numWarnings = 0;
	var numRna = 0;
	var numStratagene = 0;
	var numExternal = 0;
	for (var i = 0; i < wells.length; i++)
	{
		var well = wells[i];
		var rna = well.extract;
		if (well.hasWarning())
		{
			numWarnings++;
		}
		if (well.hasError())
		{
			numErrors++;
		}
		else
		{
			if (rna && rna.id)
			{
				var tmp = {};
				tmp.row = well.row;
				tmp.column = well.column;
				tmp.rna = {};
				tmp.rna.id = rna.id;
				tmp.rna.usedQuantity = rna.qc ? QUANTITY_QC : QUANTITY_REGULAR;
				tmp.rna.comment = rna.comment;
				plateInfo.wells[plateInfo.wells.length] = tmp;
				numRna++;
				if (rna.stratagene) numStratagene++;
				if (rna.external) numExternal++;
			}
		}
	}

	var flagged = Rna.getFlagged();
	for (var i = 0; i < flagged.length; i++)
	{
		var rna = flagged[i];
		var tmp = {};
		tmp.id = rna.id;
		tmp.flag = rna.flag;
		tmp.comment = rna.comment;
		flaggedRnaInfo[flaggedRnaInfo.length] = tmp;
	}
	
	if (numErrors > 0)
	{
		alert('There are ' + numErrors + ' wells with errors. Please fix them before creating the mRNA plate.');
		return;
	}

	if (numRna == 0)
	{
		alert('There is no RNA in any wells');
		return;
	}
	
	if (numWarnings > 0)
	{
		if (!confirm('There are ' + numWarnings + ' wells with a warning. Continue anyway?')) return;
	}
	
	if (schema)
	{
		var numPrimary = schema.numPools * schema.numWellsPerPool;
		if (numRna < numPrimary)
		{
			if (!confirm('Some of the primary wells are missing RNA. Continue anyway?')) return;
		}
	}
	
	if (numRna == numStratagene+numExternal)
	{
		if (!confirm('There are only wells with Stratagene or external RNA on this plate. Continue anyway?')) return;
	}
	
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.hide('gocancel');
	Main.hide('gocreate');

	if (debug) Main.debug(JSON.stringify(submitInfo));

	var request = Ajax.getXmlHttpRequest();
	var url = '../MRna.servlet?ID=<%=ID%>';
	url += '&cmd=CreateMRnaPlate';
	request.open("POST", url, false);
	request.setRequestHeader("Content-Type", "application/json");
	request.send(JSON.stringify(submitInfo));

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}

	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');
}

function toggleInfo(what)
{
	var frm = document.forms['reggie'];
	var show = frm[what].checked;
	Main.addOrRemoveClass(document.getElementById('plate'), 'hide-'+what, !show);
}

function showFlaggedRna()
{
	currentSelected = Plate.getSelected();
	currentIndex = 0;

	var flagged = Rna.getFlagged();
	Main.openPopup('show_flagged_rna.jsp?ID=<%=ID%>&numFlagged='+flagged.length+'&numSelected='+currentSelected.length, 'FlaggedRna', 800, 500);
}

function poolSchemaOnChange()
{
	var frm = document.forms['reggie'];
	var schema = POOL_SCHEMA[frm.pool_schema.selectedIndex];
	Plate.setPoolSchema(schema);
	Plate.paint(Plate.getWells());
	PoolSchema.buildPoolTableRow(schema, Plate.columns, true);
}

function quantityOnBlur()
{
	var frm = document.forms['reggie'];
	quantitiesAreValid = false;
	setInnerHTML('gonext.message', '');
	
	var qRegular = parseFloat(frm.quantity_regular.value);
	if (!(qRegular > 0))
	{
		setInputStatus('quantities', 'Amount must be ≥ 0.', 'invalid');
		return;
	}
	var qQc = parseFloat(frm.quantity_qc.value);
	if (!(qQc > qRegular))
	{
		setInputStatus('quantities', 'Amount QC must be &gt; ' + qRegular + '.', 'invalid');
		return;
	}
	
	quantitiesAreValid = true;
	QUANTITY_REGULAR = qRegular;
	QUANTITY_QC = qQc;
	setInputStatus('quantities', '', 'valid');
	Plate.paint(Plate.getWells());
}

function warningLevelOnBlur()
{
	var frm = document.forms['reggie'];
	
	var wQuantity = parseFloat(frm.warning_quantity.value);
	if (!(wQuantity > 0))
	{
		setInputStatus('warnings', 'Remaining quantity must be ≥ 0.', 'invalid');
		return;
	}
	var wQualityScore = parseFloat(frm.warning_quality_score.value);
	if (!(wQualityScore > 0))
	{
		setInputStatus('warnings', 'RQS/RIN must be ≥ 0.', 'invalid');
		return;
	}
	
	LOW_QUANTITY_WARNING_LIMIT = wQuantity;
	QUALITY_SCORE_WARNING_LIMIT = wQualityScore;
	setInputStatus('warnings', '', 'valid');
	Plate.paint(Plate.getWells());
}


</script>
<style>

/* Empty wells should have greyed, italic text */
.well.empty
{
	text-align: center;
	vertical-align: middle;
	font-style: italic;
	color: #999999;
}

/* A well assigned for QC include a background icon as indicator */
.well.qc
{
	background-image: url('../images/mrnaqc.png');
	background-position: 98% 25%;
	background-repeat: no-repeat;
}

/* A well which contain replicate RNA is also marked with an icon */
.well.replicate
{
	background-image: url('../images/copy.png');
	background-position: 98% 25%;
	background-repeat: no-repeat;
}

/* A well that is both a replicate and QC need to re-arrange the icons a bit */
.well.qc.replicate
{
	background-image: url('../images/mrnaqc.png'), url('../images/copy.png');
	background-position: 98% 25%, 98% 75%;
	background-repeat: no-repeat;
}

.well .missing
{
	font-style: italic;
}

.plate.hide-location .location
{
	display: none;
}
.plate.hide-quantity .quantity
{
	display: none;
}
.plate.hide-volumes .volumes
{
	display: none;
}
.plate.hide-ndconc .ndconc
{
	display: none;
}
.plate.hide-quality-score .quality-score
{
	display: none;
}
.plate.hide-qiacube-date .qiacube-date
{
	display: none;
}
.volume
{
	color: #C80000;
}
.water
{
	color: #0000C8;
}
.comment
{
	font-style: italic;
}
#iconSpecialSelect
{
	cursor: pointer;
}
#flaggedRna:before
{
	content: url('../images/flag.png');
	padding-right: 4px;
}
</style>
</base:head>
<base:body onload="init()">
	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Create new mRNA plate" 
		/></p:path>
	<div id="canvas" class="absolutefull" style="z-index: -1;">
	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the wizard but 
			created items will not be shared.
		</div>
		<%
	}
	%>
	<m:menu
		id="menuSpecialSelect"
		style="display: none; font-weight: normal; text-align: left;">
		<m:menuitem 
			title="All" 
			onclick="specialToggle('all')"
			tooltip="Select/deselect all wells on the plate"
		/>
		<m:menuitem 
			title="None" 
			onclick="specialToggle('none')"
			tooltip="Deselect all wells on the plate (no toggle!)"
		/>
		<m:menuitem 
			title="Primary" 
			onclick="specialToggle('pools')"
			tooltip="Select/deselect all primary wells on the plate"
		/>
		<m:menuitem 
			title="All empty" 
			onclick="specialToggle('empty')"
			tooltip="Select/deselect all empty wells on the plate"
		/>
		<m:menuitem 
			title="Empty in primary" 
			onclick="specialToggle('empty-pools')"
			tooltip="Select/deselect all empty primary wells on the plate"
		/>
		<m:menuseparator />
		<m:menuitem 
			icon="<%=home+"/images/stratagene.png"%>"
			title="Stratagene" 
			onclick="specialToggle('stratagene')"
			tooltip="Select/deselect all wells with Stratagene"
		/>
		<m:menuitem 
			icon="<%=home+"/images/external.png"%>"
			title="External" 
			onclick="specialToggle('external')"
			tooltip="Select/deselect all wells with external RNA"
		/>
		<m:menuitem 
			icon="<%=home+"/images/copy.png"%>"
			title="Replicates" 
			onclick="specialToggle('replicates')"
			tooltip="Select/deselect all wells with replicated RNA"
		/>
		<m:menuitem 
			icon="<%=home+"/images/error.png"%>"
			title="Error" 
			onclick="specialToggle('error')"
			tooltip="Select/deselect all wells with an error"
		/>
		<m:menuitem 
			icon="<%=home+"/images/warning.png"%>"
			title="Warning" 
			onclick="specialToggle('warning')"
			tooltip="Select/deselect all wells with an error"
		/>
	</m:menu>
	
	<m:menu
		id="menuContext"
		style="display: none; font-weight: normal; text-align: left;">
		<m:menuitem 
			title="Comments&hellip;" 
			icon="<%=home+"/images/comment.png"%>" 
			onclick="commentSelected()"
			tooltip="Add a comment to the selected wells"
		/>
		<m:menuitem 
			title="Toggle QC" 
			icon="<%=home+"/images/mrnaqc.png"%>" 
			onclick="toggleQc()" 
			tooltip="Select/deselect RNA for QC" 
		/>
		<m:menuseparator />
		<m:menuitem 
			title="Cut&hellip;" 
			icon="<%=home+"/images/cut.png"%>" 
			onclick="cutSelected()" 
			tooltip="Clear the selected wells" 
		/>
		<m:menuitem  
			title="Copy" 
			icon="<%=home+"/images/copy.png"%>" 
			onclick="copySelected()" 
			tooltip="Make a copy of the selected RNA" 
		/>
		<m:menuitem  
			title="Paste" 
			icon="<%=home+"/images/paste.png"%>" 
			onclick="pasteToSelected()" 
			tooltip="Paste RNA into selected wells" 
		/>
		<m:menuitem  
			title="Switch" 
			icon="<%=home+"/images/switch.png"%>" 
			onclick="switchSelected()" 
			tooltip="Switch the selected wells (if exactly two)" 
		/>
		<m:menuseparator />
		<m:submenu
			subid="flagMenu"
			title="Flag"
			icon="<%=home+"/images/flag.png"%>"
		/>
		<m:menuseparator id="sepCaseSummary" />
		<m:menuitem
			id="mnuCaseSummary"
			icon="<%=home+"/images/case_summary.png"%>"
			onclick="showCaseSummary()"
			tooltip="Show case summary"
			title="Case summary&hellip;"
		/>
	</m:menu>

	<m:menu
		id="flagMenu"
		style="display: none;"
		>
		<m:menuitem 
			title="LowQualityScore" 
			onclick="flagSelected('LowQualityScore')"
			tooltip="Flag the selected RNA as having a too low RQS/RIN value"
		/>
		<m:menuitem 
			title="NotEnoughRemainingQuantity" 
			onclick="flagSelected('NotEnoughRemainingQuantity')"
			tooltip="Flag the selected RNA as having too little remaining quantity"
		/>
		<m:menuseparator />
		<m:menuitem 
			title="Other..." 
			onclick="flagSelected('ManualFlag')"
			tooltip="Flag the selected RNA for some other reason"
		/>
	</m:menu>

	<form name="reggie">
	
	<table class="stepform" id="step.1.section" style="width: auto;">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Fragmented mRNA plate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table class="bottomborder" style="width: 100%;">
			<tr>
				<td class="prompt">Name</td>
				<td class="input" id="plateName"></td>
				<td class="status"></td>
				<td class="help">Select RNA items to use for the new mRNA plate.</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Preliminary pool layout</td>
				<td class="input">
					<select name="pool_schema" onchange="poolSchemaOnChange()" style="width: 25em;" class="required"></select>
				</td>
				<td class="status"></td>
				<td class="help">Preliminary pool layout (can be changed later).</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Stratagene to use</td>
				<td class="input">
					<select name="stratagene" style="width: 25em;" class="required"></select>
				</td>
				<td class="status"></td>
				<td class="help">
					Select the Stratagene tube to use. If not known, the
					generic <b>Stratagene.r</b> should be used.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Amount of RNA</td>
				<td class="input">
					Normal <input type="text" class="text required" name="quantity_regular" 
						value="1.1" style="width: 4em;"
						onblur="quantityOnBlur()"
						onkeypress="return Numbers.numberOnly(event)">µg,
					QC <input type="text" class="text required" name="quantity_qc" 
						value="1.22" style="width: 4em;"
						onblur="quantityOnBlur()"
						onkeypress="return Numbers.numberOnly(event)">µg
				</td>
				<td class="status" id="quantities.status"></td>
				<td class="help">
					<span id="quantities.message" class="message" style="display: none;"></span>
					Specify the amount of RNA to use. Aliquots for QC usually need 0.12µg extra.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input">
					<textarea rows="2" style="width: 90%;" name="comments" value=""></textarea>
				</td>
				<td class="status"></td>
				<td class="help">Comments about the new mRNA plate.</td>
			</tr>
			<tr style="vertical-align: top;">
				<td class="prompt">Show</td>
				<td class="input" colspan="2">
					<table>
					<tr valign="top">
						<td>
							<input type="checkbox" name="location" id="location" onclick="toggleInfo('location')" checked><label for="location">Bioplate location</label><br>
							<input type="checkbox" name="quantity" id="quantity" onclick="toggleInfo('quantity')" checked><label for="quantity">Remaining quantity</label><br>
						</td>
						<td>
							<input type="checkbox" name="quality-score" id="quality-score" onclick="toggleInfo('quality-score')"><label for="quality-score">RQS/RIN</label><br>
							<input type="checkbox" name="ndconc" id="ndconc" onclick="toggleInfo('ndconc')"><label for="ndconc">NDConc</label><br>
						</td>
						<td>
							<input type="checkbox" name="volumes" id="volumes" onclick="toggleInfo('volumes')"><label for="volumes">Used volume+water</label><br>
							<input type="checkbox" name="qiacube-date" id="qiacube-date" onclick="toggleInfo('qiacube-date')"><label for="qiacube-date">QiaCube date</label><br>
						</td>
					</tr>
					</table>
				</td>
				<td class="help">Toggles visiblity of the selected information inside each well on the plate.</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Warning levels</td>
				<td class="input">
					Remaining quantity&lt;<input type="text" class="text" name="warning_quantity" 
						value="2.2" style="width: 4em;"
						onblur="warningLevelOnBlur()"
						onkeypress="return Numbers.numberOnly(event)">µg,
					RQS/RIN&lt;<input type="text" class="text" name="warning_quality_score" 
						value="8" style="width: 4em;"
						onblur="warningLevelOnBlur()"
						onkeypress="return Numbers.numberOnly(event)">
				</td>
				<td class="status" id="warnings.status"></td>
				<td class="help">
					<span id="warnings.message" class="message" style="display: none;"></span>
					Warning levels for remaining quantity and RQS/RIN values.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	
	<tr>
		<td>
			<tbl:toolbar subclass="bottomborder">
				<tbl:button 
					title="Load from file&hellip;" 
					image="<%=home+"/images/file.png"%>" 
					onclick="selectFile()" 
					tooltip="Load plate design from file"
				/>
				
				<tbl:button 
					title="Auto-select&hellip;" 
					image="<%=home+"/images/wizard.png"%>" 
					onclick="autoSelect()" 
					tooltip="Let the wizard auto-select RNA"
				/>
				<tbl:button 
					title="Manual select&hellip;" 
					image="<%=home+"/images/manual_rna.png"%>" 
					onclick="manualSelect()" 
					tooltip="Manually select RNA items" 
				/>
				<tbl:button 
					title="Stratagene" 
					image="<%=home+"/images/stratagene.png"%>" 
					onclick="setToStratagene()" 
					tooltip="Place stratagene in the selected wells" 
				/>
				<tbl:button 
					title="External" 
					image="<%=home+"/images/external.png"%>" 
					onclick="setToExternal()" 
					tooltip="Mark selected wells as used by external RNA" 
				/>
				<tbl:button 
					title="Toggle QC" 
					image="<%=home+"/images/mrnaqc.png"%>" 
					onclick="toggleQc()" 
					tooltip="Select/deselect RNA for QC" 
				/>
				<tbl:button 
					title="Comments&hellip;" 
					image="<%=home+"/images/comment.png"%>" 
					onclick="commentSelected()" 
					tooltip="Add a comment to the selected wells" 
				/>
				<tbl:button 
					title="Cut&hellip;" 
					image="<%=home+"/images/cut.png"%>" 
					onclick="cutSelected()" 
					tooltip="Clear the selected wells" 
				/>
				<tbl:button 
					title="Copy" 
					image="<%=home+"/images/copy.png"%>" 
					onclick="copySelected()" 
					tooltip="Make a copy of the selected RNA" 
				/>
				<tbl:button 
					title="Paste" 
					image="<%=home+"/images/paste.png"%>" 
					onclick="pasteToSelected()" 
					tooltip="Paste RNA into selected wells" 
				/>
				<tbl:button 
					title="Switch" 
					image="<%=home+"/images/switch.png"%>" 
					onclick="switchSelected()" 
					tooltip="Switch the selected wells (if exactly two)" 
				/>
			</tbl:toolbar>
				<div id="flaggedRna" style="margin: 0.5em 1em 0 1em; display: none; " class="link" onclick="showFlaggedRna()">
					Flagged RNA items.
				</div>

				<table class="plate hide-volumes hide-ndconc hide-quality-score hide-qiacube-date" style="margin: 1em 1em 0 1em;" id="plate"
					onmouseup="contextEvent(event)"
					oncontextmenu="contextEvent(event)"
					>
				<%
				int columns = 12;
				int rows = 8;
				WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
				WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
				%>
				<tr class="header">
					<th>
						<base:icon image="<%=home+"/images/select_all.png"%>" 
							id="iconSpecialSelect"
							tooltip="Select/deselect wells on the plate with specific condition" 
						>
					</base:icon>
				</th>
					<%
					for (int c = 0; c < columns; ++c)
					{
						%>
						<th class="link" id="col.<%=c%>"
							onclick="toggleColumn(<%=c%>)" 
							onmouseover="highlightColumn(<%=c%>, true)"
							onmouseout="highlightColumn(<%=c%>, false)"
							title="Select/deselect all wells in this column"><%=colF.format(c)%></th>
						<%
					}
					%>
				</tr>
				<tbody>
				<%
				for (int r = 0; r < rows; ++r)
				{
					String row = rowF.format(r);
					%>
					<tr class="row-<%=r%>">
						<th class="link" id="row.<%=r%>"
							onclick="toggleRow(<%=r%>)"
							onmouseover="highlightRow(<%=r%>, true)"
							onmouseout="highlightRow(<%=r%>, false)"
							title="Select/deselect all wells in this row"><%=row%></th>
						<%
						for (int c = 0; c < columns; ++c)
						{
							%>
							<td id="well.<%=r%>.<%=c%>" class="well empty primary"
								onclick="toggleWell(<%=r%>,<%=c%>)"
								onmouseenter="highlightReplicated(<%=r%>, <%=c%>, true)" 
								onmouseleave="highlightReplicated(<%=r%>, <%=c%>, false)"
								title="Select/deselect this well">empty</td>
							<%
						}
						%>
					</tr>
					<%
				}
				%>
				</tbody>
				<tr id="pool-row" 
					onclick="poolOnClick(event)" 
					onmouseover="poolEnter(event)" 
					onmouseout="poolLeave(event)">
					<th colspan="13">&nbsp;</th>
				</tr>
				</table>
				<div style="padding-left: 1em; padding-bottom: 0.5em; padding-top: 2px;">
					<base:icon image="<%=home+"/images/mrnaqc.png"%>" />=Selected for QC
					<base:icon image="<%=home+"/images/copy.png"%>" style="padding-left: 1em;" />=Replicated RNA
					<base:icon image="<%=home+"/images/error.png"%>" style="padding-left: 1em;" />=Error that prevent plate creation
					<base:icon image="<%=home+"/images/warning.png"%>" style="padding-left: 1em;" />=Warning but plate can be created
				</div>
		</td>
	</tr>
	</table>
	

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" /></td>
		<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
		<td id="gonext.message" class="message"></td>
	</tr>
	</table>
	</form>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
</div>
	</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>